import oscP5.*;
import netP5.*;
import codeanticode.syphon.*;

SyphonServer server;
  
OscP5 oscP5;
NetAddress myRemoteLocation;

float rotateX;
float rotateY;
color bgColor;

void setup() {

  frameRate(25);
  size(600,600, P3D);
  
  bgColor = color(0,0,0,0);
  
  // Create syhpon server to send frames out.
  server = new SyphonServer(this, "Processing Syphon");
  
  /* start oscP5, listening for incoming messages at port 8000 */
  oscP5 = new OscP5(this,8000);
  
}

void draw() {
  background(bgColor);
  lights();
  translate(width/2, height/2);
  rotateX(rotateX);
  rotateY(rotateY);  
  box(150);
}


/* incoming osc message are forwarded to the oscEvent method. */
void oscEvent(OscMessage theOscMessage) {
  /* print the address pattern and the typetag of the received OscMessage */
  print("### received an osc message.");
  print(" addrpattern: "+theOscMessage.addrPattern());
  println(" typetag: "+theOscMessage.typetag());
  if(theOscMessage.checkAddrPattern("/cube/rotx")==true) {
    /* check if the typetag is the right one. */
    if(theOscMessage.checkTypetag("f")) {
      /* parse theOscMessage and extract the values from the osc message arguments. */
      rotateX = theOscMessage.get(0).floatValue();
      return;
    }  
  }
  else if(theOscMessage.checkAddrPattern("/cube/roty")==true) {
    /* check if the typetag is the right one. */
    if(theOscMessage.checkTypetag("f")) {
      /* parse theOscMessage and extract the values from the osc message arguments. */
      rotateY = theOscMessage.get(0).floatValue();  
      return;
    }  
  }
  else if(theOscMessage.checkAddrPattern("/cube/rot")==true) {
    /* check if the typetag is the right one. */
    if(theOscMessage.checkTypetag("ff")) {
      /* parse theOscMessage and extract the values from the osc message arguments. */
      rotateX = theOscMessage.get(0).floatValue();
      rotateY = theOscMessage.get(1).floatValue();
      return;
    }
  }
}
